package com.malk.suodisi.controller;

import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSON;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.common.McException;
import com.malk.service.aliwork.YDClient;
import com.malk.utils.UtilServlet;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 错误抛出与拦截详见 CatchException
 */
@Slf4j
@RestController
@RequestMapping
public class SDSController {
    
    @Autowired
    private YDClient ydClient;

    /**
     * 动态审批人
     */
    @PostMapping("sds/test")
    List<String> sdsTest(HttpServletRequest request) {
        Map param = UtilServlet.getParamMap(request);
        McException.assertParamException_Null(param, "finance");
        Map condition = new HashMap();
        condition.put("textField_lg52q035", param.get("finance"));
        YDParam ydParam = YDParam.builder()
                .appType("APP_Y75CEY3YR30YOLEWETJJ")
                .systemToken("BY866R813JM8XVLGD7YELCPDH9IL29Z5BQQEL48")
                .formUuid("FORM-8Y866XB1AXM9DFV3AW6D7AV2WWEK2F3OP25GLD")
                .searchFieldJson(JSON.toJSONString(condition))
                .build();
        List<Map> list = (List<Map>) ydClient.queryData(ydParam, YDConf.FORM_QUERY.retrieve_search_form).getData();
        Map formData = (Map) list.get(0).get("formData");
        log.info("索迪斯动态审批人, {}, {}", param, formData);

        return (List<String>) formData.get("employeeField_lg52q036_id");
    }

    /**
     * 回写招聘子表
     */
    @PostMapping("sds/update")
    Map sdsUpdate(HttpServletRequest request) {

        // 查询招聘申请
        Map param = UtilServlet.getParamMap(request);
        McException.assertParamException_Null(param, "formInstId");
        YDParam ydParam = YDParam.builder()
                .appType("APP_Y75CEY3YR30YOLEWETJJ")
                .systemToken("BY866R813JM8XVLGD7YELCPDH9IL29Z5BQQEL48")
                .formInstId(String.valueOf(param.get("formInstId")))
                .build();
        Map rsp = (Map) ydClient.operateData(ydParam, YDConf.FORM_OPERATION.update);
        Map formData = (Map) rsp.get("formData");
        log.info("索迪斯回写子表, {}, {}", param, formData);

        // 组装分发子表数据
        Map detail = new HashMap();
        detail.put("associationFormField_lf7pkag4", JSON.parse(String.valueOf(formData.get("associationFormField_lg54gbt9_id")))); // 职位组
        detail.put("textField_lf7pkag5", formData.get("textField_lg54gbta")); // 新员工姓名
        detail.put("dateField_lf7pkag6", formData.get("dateField_lg54gbtf")); // 入职日期

        // todo: 成员, 附件, 关联表单
        List<Map> association = JSON.parseArray(String.valueOf(JSON.parse(String.valueOf(formData.get("associationFormField_lg0gmbi8_id")))), Map.class);
        String formInstId = String.valueOf(association.get(0).get("instanceId"));
        ydParam.setFormInstId(formInstId);
        Map rspSrc = (Map) ydClient.operateData(ydParam, YDConf.FORM_OPERATION.update);
        Map formDataSrc = (Map) rspSrc.get("formData");
        List<Map> list = new ArrayList<>();
        if (ObjectUtil.isNotNull(formDataSrc.get("tableField_lf7pkag3"))) {
            list = (List<Map>) formDataSrc.get("tableField_lf7pkag3");
        }

        // 更新流程数据
        Map form = new HashMap();
        list.add(detail);
        form.put("tableField_lf7pkag3", list);
        form.put("numberField_lfj9d501", 2);
        ydParam.setUpdateFormDataJson(JSON.toJSONString(form));
        ydClient.operateData(ydParam, YDConf.FORM_OPERATION.update);

        log.info("更新, {}, {}", formInstId, form);

        Map r = new HashMap();
        r.put("success", true);
        return r;
    }
}


